taffybar-3.2.2: A desktop bar similar to xmobar, but with more GUI

Copyright | (c) José A. Romero L.
License | BSD3-style (see LICENSE)
Maintainer | Ivan Malison <IvanMalison@gmail.com>
Stability | unstable
Portability | unportable
Safe Haskell | None
Language | Haskell2010

System.Taffybar.Information.X11DesktopInfo

Description

Low-level functions to access data provided by the X11 desktop via window properties. One of them (`getVisibleTags`) depends on the PagerHints hook being installed in your `~/.xmonad/xmonad.hs` configuration:

    import System.Taffybar.Support.PagerHints (pagerHints)

    main = xmonad $ ewmh $ pagerHints $ ...

Synopsis

- data X11Context = X11Context {
  - contextDisplay :: Display
  - _contextRoot :: Window
  - atomCache :: MVar [(String, Atom)]
  }
- type X11Property a = ReaderT X11Context IO a
- type X11Window = Window
- doLowerWindow :: X11Window -> X11Property ()
- eventLoop :: (Event -> IO ()) -> X11Property ()
- fetch :: Integral a => PropertyFetcher a -> Maybe X11Window -> String -> X11Property (Maybe [a])
- getAtom :: String -> X11Property Atom
- getDefaultCtx :: IO X11Context
- getDisplay :: X11Property Display
- getPrimaryOutputNumber :: X11Property (Maybe Int)
- getVisibleTags :: X11Property [String]
- isWindowUrgent :: X11Window -> X11Property Bool
- postX11RequestSyncProp :: X11Property a -> a -> X11Property a
- readAsInt :: Maybe X11Window -> String -> X11Property Int
- readAsListOfInt :: Maybe X11Window -> String -> X11Property [Int]
- readAsListOfString :: Maybe X11Window -> String -> X11Property [String]
- readAsListOfWindow :: Maybe X11Window -> String -> X11Property [X11Window]
- readAsString :: Maybe X11Window -> String -> X11Property String
- sendCommandEvent :: Atom -> Atom -> X11Property ()
- sendWindowEvent :: Atom -> X11Window -> X11Property ()
- withDefaultCtx :: X11Property a -> IO a

# Documentation

data X11Context Source #

Constructors

X11Context |

Fields

- contextDisplay :: Display
- _contextRoot :: Window
- atomCache :: MVar [(String, Atom)]

type X11Property a = ReaderT X11Context IO a Source #

type X11Window = Window Source #

doLowerWindow :: X11Window -> X11Property () Source #

Move the X11Windows to the bottom of the X11 window stack.

eventLoop :: (Event -> IO ()) -> X11Property () Source #

Spawn a new thread and listen inside it to all incoming events, invoking the given function to every event of type `MapNotifyEvent` that arrives, and subscribing to all events of this type emitted by newly created windows.

fetch Source #

Arguments

:: Integral a |
=> PropertyFetcher a | Function to use to retrieve the property.
-> Maybe X11Window | Window to read from. Nothing means the root Window.
-> String | Name of the property to retrieve.
-> X11Property (Maybe [a]) |

Apply the given function to the given window in order to obtain the X11 property with the given name, or Nothing if no such property can be read.

getAtom :: String -> X11Property Atom Source #

Return the Atom with the given name.

getDefaultCtx :: IO X11Context Source #

Build a new `X11Context` containing the current X11 display and its root window.

getDisplay :: X11Property Display Source #

An X11Property that returns the `Display` object stored in the X11Context.

getPrimaryOutputNumber :: X11Property (Maybe Int) Source #

Get the index of the primary monitor as set and ordered by Xrandr.

getVisibleTags :: X11Property [String] Source #

Retrieve the value of the special _XMONAD_VISIBLE_WORKSPACES hint set by the PagerHints hook provided by Taffybar (see module documentation for instructions on how to do this), or an empty list of strings if the PagerHints hook is not available.

isWindowUrgent :: X11Window -> X11Property Bool Source #

Determine whether the "urgent" flag is set in the WM_HINTS of the given window.

postX11RequestSyncProp :: X11Property a -> a -> X11Property a Source #

Post the provided X11Property to taffybar's dedicated X11 thread, and wait for the result. The provided default value will be returned in the case of an error.

readAsInt Source #

Arguments

:: Maybe X11Window | window to read from. Nothing means the root window.
-> String | name of the property to retrieve
-> X11Property Int |

Retrieve the property of the given window (or the root window, if Nothing) with the given name as a value of type Int. If that property hasn't been set, then return -1.

readAsListOfInt Source #

Arguments

:: Maybe X11Window | window to read from. Nothing means the root window.
-> String | name of the property to retrieve
-> X11Property [Int] |

Retrieve the property of the given window (or the root window, if Nothing) with the given name as a list of Ints. If that property hasn't been set, then return an empty list.

readAsListOfString Source #

Arguments

:: Maybe X11Window | window to read from. Nothing means the root window.
-> String | name of the property to retrieve
-> X11Property [String] |

Retrieve the property of the given window (or the root window, if Nothing) with the given name as a list of Strings. If the property hasn't been set, then return an empty list.

readAsListOfWindow Source #

Arguments

:: Maybe X11Window | window to read from. Nothing means the root window.
-> String | name of the property to retrieve
-> X11Property [X11Window] |

Retrieve the property of the given window (or the root window, if Nothing) with the given name as a list of X11 Window IDs. If the property hasn't been set, then return an empty list.

readAsString Source #

Arguments

:: Maybe X11Window | window to read from. Nothing means the root window.
-> String | name of the property to retrieve
-> X11Property String |

Retrieve the property of the given window (or the root window, if Nothing) with the given name as a String. If the property hasn't been set, then return an empty string.

sendCommandEvent :: Atom -> Atom -> X11Property () Source #

Emit a "command" event with one argument for the X server. This is used to send events that can be received by event hooks in the XMonad process and acted upon in that context.

sendWindowEvent :: Atom -> X11Window -> X11Property () Source #

Similar to `sendCommandEvent`, but with an argument of type Window.

withDefaultCtx :: X11Property a -> IO a Source #

Put the current display and root window objects inside a Reader transformer for further computation.